﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GGJ2015LevelCreator
{  
    public static class Tiles
    {
        public static char Boundary { get { return '*'; } }
        public static char Air { get { return ' '; } }
        public static char Start { get { return 'S'; } }
        public static char Finish { get { return 'F'; } }
        public static char Entrance { get { return 'E'; } }
        public static char Exit { get { return 'X'; } }
        public static char Block { get { return 'B'; } }
        public static char Water { get { return 'W'; } }
        public static char Damageable { get { return 'D'; } }

        public static bool IsSolid (this char tile)
        {
            return tile == Boundary || tile == Block || tile == Damageable;
        }

        public static bool IsInvinskible(this char tile)
        {
            return tile == Boundary || tile == Block;
        }

        public static bool IsDestructable(this char tile)
        {
            return tile == Damageable;
        }

        public static bool IsPassable(this char tile)
        {
            return tile == Damageable || tile == Air;
        }

        //public static bool HasImpossibleColumn(this char[,] tiles, int yPosition)
        //{
        //    return tile == Boundary || tile == Block || tile == Damageable;
        //}
    }
}
