#ifndef CONSTANTS_HPP_INCLUDE
#define CONSTANTS_HPP_INCLUDE

#include <string>

enum Effects {
	EFF_NONE = 0,
	EFF_BREAK = 1,
	EFF_FREEZE = 2,
	EFF_DIG = 4,
	EFF_DRAIN = 8,
	EFF_MOVE = 16
};

enum Results {
	RES_DOOMED,
	RES_ADD_GRAV,
	RES_BORING,
	RES_MOVE,
	RES_NONE
};

const float ASCII_SPACING = 1.0f / 95.0f;
const float TEXT_SIZE = 0.025;

const float GRAVITY = 0.0025f;
const float VELOCITY_DECAY = 0.9f;

const float SMALL_FLOAT = 0.001;

const float PLAYER_SPEED = 0.0015f;
const float JUMP_SPEED = 0.04f;
const float BULLET_SPEED = 0.04f;

const int FRAME_COOL_DOWN = 5;
const float FADE_SPEED = 0.05f;
const int FIRING_TIME = 5;

const float X_SHOULDER = 0.47f;
const float Y_SHOULDER = 0.44f;

const float PLAYER_TOP_LEFT_X = 0.16f;
const float PLAYER_TOP_LEFT_Y = 0.09f;
const float PLAYER_BOTTOM_RIGHT_X = 0.77f;
const float PLAYER_BOTTOM_RIGHT_Y = 0.87f;

const int ROOM_SIZE_X = 10;
const int ROOM_SIZE_Y = 7;

#endif
