#ifndef GUN_HPP_INCLUDE
#define GUN_HPP_INCLUDE

#include <math.h>
#include "Position.hpp"
#include "Sprite.hpp"
#include "GunList.hpp"

struct Bullet {
	Position pos;
	Sprite sprite;
	int life;

	Bullet (Position posIn = Position(), Sprite spriteIn = Sprite(), int lifeIn = -1) : pos(posIn), sprite(spriteIn), life(lifeIn) {}
};

class Gun
{
	public:
		Gun () {}
		Gun (GunListData data) { init(data); }
		~Gun() {}

		void init(GunListData data);

		void update();

		void draw(Position pos, bool drawGun);

		bool shoot(Position aim);

		float recoil() { return recoil_; }

		void setRow(int row) { gunGfx_.texPos().y = gunGfx_.texDim().y * row; }

	protected:
		std::string name_;

		std::string bangFile_;
		std::string hitFile_;

		Sprite gunGfx_;
		Sprite bulletGfx_;

		std::vector<Bullet> bullets_;

		float recoil_;
		int shotLim_;
		int life_;

		int fired_;
		int effects_;

	private:
};

#endif
