#ifndef GUNLIST_H_INCLUDED
#define GUNLIST_H_INCLUDED

#include "Constants.hpp"

struct GunListData {
	std::string name;

	std::string bangFile;
	std::string hitFile;

	std::string gFileName;
	std::string bFileName;

	float recoil;
	int shotLim;
	int life;

	int effects;

	GunListData (std::string nameIn = "", std::string bangFileIn = "", std::string hitFileIn = "", std::string gFileNameIn = "", std::string bFileNameIn = "", float recoilIn = 0.0f, int shotLimIn = 1, int lifeIn = -1, int effectsIn = EFF_NONE)
		: name(nameIn), bangFile(bangFileIn), hitFile(hitFileIn), gFileName(gFileNameIn), bFileName(bFileNameIn), recoil(recoilIn), shotLim(shotLimIn), life(lifeIn), effects(effectsIn) {}
};

const GunListData gunList[] = {
	GunListData(
		"Cannon",
		"audio/cannonfire.wav",
		"audio/bulletimpact1.wav",

		"gfx/Cannon_Spritesheet.png",
		"gfx/Cannonball.png",

		0.01f,
		1,
		-1,

		EFF_BREAK),
	GunListData(
		"Ice wand",

		"audio/freezefire.wav",
		"audio/freezeimpact.wav",

		"gfx/Icewand_Spritesheet.png",
		"gfx/IceBlast.png",

		0.0f,
		10,
		-1,

		EFF_FREEZE),
	GunListData(
		"Drain beam",

		"audio/Drainbeam_Shoot.wav",
		"audio/Drainbeam_Impact.wav",

		"gfx/DrainBeam_Spritesheet.png",
		"gfx/DrainBeam_Projectile.png",

		0.0f,
		20,
		-1,

		EFF_DRAIN),
	GunListData(
		"Mole mitt",

		"",
		"audio/MolemittImpact.wav",

		"gfx/Molemitt_Spritesheet.png",
		"0",

		0.0f,
		20,
		3,

		EFF_DIG),
  GunListData("Gravity Beam", "audio/MagnetHand_Fire.wav", "audio/freezeimpact.wav", "gfx/MagnetHand_Spritesheet.png",
              "gfx/MagnetHand_Projectile.png", 0.0005f, 20, -1, EFF_MOVE)
};

const int gunListLen = sizeof(gunList) / sizeof(GunListData);

/*
GunListData(
		"",

		"audio/.wav",
		"audio/.wav",

		"gfx/.png",
		"gfx/.png",

		0.0f,
		0,

		EFF_NONE),
*/

#endif
