#ifndef PLAYER_HPP_INCLUDE
#define PLAYER_HPP_INCLUDE

#include <vector>
#include "Position.hpp"
#include "Sprite.hpp"
#include "Gun.hpp"
#include <map>

class Player
{
	public:
		Player () {}
		~Player() {}

		void init();

		void update();

		void draw();

		bool dead() { return dead_; }
		void kill();
		void resurrect() { dead_ = false; }

		Position& pos() { return pos_; }

		std::vector<Gun>* guns() { return &guns_; }
    std::map<char, int>& gunMap() { return gunMap_; }

    int& gunIndex() { return gunIndex_; }

		Sprite* sprite() { return &sprite_; }

	protected:
		Sprite sprite_;

		Position pos_;

		bool faceLeft_;

		std::vector<Gun> guns_;
		int gunIndex_;
		bool dead_;
    std::map<char, int> gunMap_;

	private:
		void updatePos();

		void updateSprite();

		void setGFXStuff(float texPosY, int frames, int row);

		bool onFloor();
};

#endif
