#ifndef PROPLIST_HPP_INCLUDED
#define PROPLIST_HPP_INCLUDED

#include "Constants.hpp"

struct PropData {
	std::string name;
	char code;

	int yIndex;

	bool obeyGravity;
	bool lethal;
	bool solid;

	int wantedEffects;

	PropData (std::string nameIn = "", char codeIn = ' ', int yIndexIn = 0, bool obeyGravityIn = true, bool lethalIn = false, bool solidIn = true, int wantedEffectsIn = EFF_NONE)
		: name(nameIn), code(codeIn), yIndex(yIndexIn), obeyGravity(obeyGravityIn), lethal(lethalIn), solid(solidIn), wantedEffects(wantedEffectsIn) {}
};

const PropData propList[] = {
	PropData("Crate", 'c', 0, true, false, true, EFF_BREAK),
	PropData("Floating block", 'l', 1, false, false, true, EFF_DRAIN),
	PropData("Gate", 'g', 2, false, false, false, EFF_NONE),
	PropData("Fire block", 'f', 3, true, true, false, EFF_FREEZE),
	PropData("Steel block", 's', 4, true, false, true, EFF_MOVE),
	PropData("Sinking block", 'd', 5, false, false, true, EFF_DRAIN),
	PropData("Quit button", 'y', 6, false, false, true, EFF_BREAK),
	PropData("Retry button", 'z', 7, false, false, true, EFF_BREAK)
};

const int propListLen = sizeof(propList) / sizeof(PropData);

#endif
