#include <fstream>
#include <random>
#include "world.hpp"
#include "Sprite.hpp"
#include "Game.hpp"
#include <random>

void World::new_room() {

  std::vector<std::string> filenames;
  std::ifstream level_list_file("levels/active_levels.txt", std::ifstream::in);
  std::string line;
  while (std::getline(level_list_file, line)) {
    filenames.push_back(line);
  }

  // Basic logic to pick the next room. At the moment do uniform int
  std::random_device rd;
  std::mt19937 generator(rd());
  std::uniform_int_distribution<> distribution(0, filenames.size() - 1);
  std::string chosen_line = filenames[distribution(generator)];
  std::string filename(chosen_line.begin(), chosen_line.end() - 3);
  Game::instance().getGuy()->guns()->clear();
  Game::instance().getGuy()->gunIndex() = 0;
  for (auto ptr_char = chosen_line.end() - 2; ptr_char != chosen_line.end(); ++ptr_char) {
    if (*ptr_char != '_') {
      int index = Game::instance().getGuy()->gunMap()[*ptr_char];
      Game::instance().getGuy()->guns()->push_back(Gun(gunList[index]));
    }
  }
  std::cout << "Loaded " << Game::instance().getGuy()->guns()->size() << " guns" << std::endl;
  Room new_room(filename);
  this->rooms_.push_back(std::move(new_room));
  this->current_room_ = &this->rooms_[this->rooms_.size() - 1];
	if(Game::instance().getGuy()->guns()->size() == 0)
		Game::instance().getGuy()->guns()->push_back(Gun(gunList[0]));
}

void World::setRoom(Room* set) { current_room_ = set; }
Room* World::getRoom(int index) { return &rooms_[index]; }

void World::update()
{
	current_room_->update();

	if(WINDOW.faded())
		new_room();
}

void World::draw() { current_room_->draw(); }
