#ifndef WORLD_HPP
#define WORLD_HPP

#include "room.hpp"

class World {
public:
  static World& instance() {
    static World the_world;
    return the_world;
  }
  ~World() { };

  void new_room();
  void init(const int room_limit) { room_limit_ = room_limit; rooms_.clear(); current_room_ = NULL; }

  Room& get_current_room() { return *current_room_; }
  Room& get_current_room() const { return *current_room_; }

  int num_rooms() const { return rooms_.size(); }
  int room_limit() const { return room_limit_; }

	void setRoom(Room* set);
	Room* getRoom(int index);

  void update();
	void draw();

private:
  // Private copy constructor - cannot copy the world
  World(const World& world);
  World() { }
  World(const int room_limit) : room_limit_(room_limit) { current_room_ = 0; };

  std::vector<Room> rooms_; // Current rooms
  Room* current_room_; // Pointer to the room we're currently in
  int room_limit_;
};

#define CURRENT_ROOM World::instance().get_current_room()

#endif
